<template>
  <div class="home">
    <div class="header">
      <div class="money">
        <img src="@/assets/img/icon_wicc@2x.png" alt>
        <span>{{balance}}</span>
      </div>
      <div class="help">
        <img src="@/assets/img/icon_record@2x.png" alt @click="openRecordModel()">
        <img src="@/assets/img/icon_problem@2x.png" alt @click="showHelpModel = !showHelpModel">
      </div>
    </div>
    <div class="count">
      <span>{{prizePoolBalance}}</span>
      <span>WICC</span>
    </div>
    <div class="odds">{{$t('index.fixedOdds')}}：7</div>
    <div class="content">
      <div class="record">
        <div class="title">{{$t('index.benifitList')}}</div>
        <div class="record-list">
          <div id="recordScroll">
            <div class="record-item" v-for="(item ,index) in benifitList" :key="index">
              <div class="address">{{subStrAddress(item.address)}}</div>
              <div class="benifit">{{$t('index.benifit')+ ((item.payMoney || 0))/Math.pow(10 ,8)}}WICC</div>
              <div>{{$t('index.benifitCode')+getDecimalSystem(item.benifitCode)}}</div>
            </div>
          </div>
        </div>
      </div>
      <div class="number">
        <div class="title">{{$t('index.pleaseSelectNum')}}</div>
        <div class="num-list" v-for="listItem in 2" :key="'list' + listItem">
          <div
            @click="selectNum = item + 4*listItem -5"
            :class="['num-btn', {'num-btn-active':item + 4*listItem -5 === selectNum}]"
            v-for="item in 4"
            :key="'num'+item"
          >{{item + 4*listItem -5}}</div>
        </div>
      </div>
    </div>
    <div class="spend-sum">
      <div class="label">
        <span>0.1</span>
        <span>10</span>
      </div>
      <div class="slider">
        <vue-slider
          v-model="spendSum"
          v-bind="sliderOption"
        ></vue-slider>
      </div>
    </div>
    <div class="btn-group">
      <div class="benift btn">
        <div>{{spendSum}}WICC</div>
        <div>{{$t('index.expectBenifit')}}{{spendSum%1 === 0 ? spendSum*7 : (spendSum*7).toFixed(1)}}WICC</div>
      </div>
      <div class="sub btn" @click="spendConfirm()">{{$t('index.confirm')}}</div>
    </div>
    <model v-model="showHelpModel">
      <div class="help-model">
        <div class="title">{{$t('index.commonQuestion')}}</div>
        <div class="intro">
          <div class="sub-title">{{$t('index.playIntroduce')}}</div>
          <div class="sub-content">{{$t('index.playIntroduceContent')}}</div>
          <div class="sub-content">{{$t('index.benifitAddr')}}</div>
          <div class="sub-content">{{$t('index.benifitAddrDetail')}}</div>
        </div>
        <div class="problem">
          <div class="sub-title">{{$t('index.possibleQuestion')}}</div>
          <div class="sub-content">
            <div class="third-title">{{$t('index.noPublishHow')}}</div>
            <div class="third-content">{{$t('index.noPublishHowContent')}}</div>
            <div class="third-title">{{$t('index.confirmSpendRight')}}</div>
            <div class="third-content">{{$t('index.confirmSpendRightContent')}}</div>
            <div class="third-title">{{$t('index.linkCustomerService')}}</div>
            <div class="third-content">{{$t('index.linkCustomerServiceContent')}}</div>
          </div>
        </div>
      </div>
    </model>
    <model v-model="showRecordModel">
      <div class="record-model">
        <div class="tab-list">
          <div
            :class="['tab-item', {'tab-item-acive': benifitModelTab === 0 }]"
            @click="benifitModelTab=0"
          >{{$t('index.mySpend')}}</div>
          <div
            :class="['tab-item', {'tab-item-acive': benifitModelTab === 1 }]"
            @click="benifitModelTab=1"
          >{{$t('index.benifitHistory')}}</div>
        </div>
        <!-- 中奖 -->
        <div class="benifit-list" v-if="benifitModelTab">
          <template v-if="benifitList.length">
            <div class="title-column">
              <div class="address-column">{{$t('index.benifitAddress')}}</div>
              <div>{{$t('index.benifitMoney')}}</div>
              <div>{{$t('index.benifitCode')}}</div>
            </div>
            <template v-for="(item, index) in benifitList.slice(-5)">
              <div class="benifit-item" :key="'item'+index" @click="showBeniiftDetail(index)">
                <div class="address">{{subStrAddress(item.address)}}</div>
                <div class="money">{{item.payMoney/Math.pow(10, 8)}}</div>
                <div class="code">
                  {{getDecimalSystem(item.benifitCode)}}
                  <img
                    src="@/assets/img/down.svg"
                    alt
                    :class="['down', {'up': currentBenifitItemShowIndex === index}]"
                  >
                </div>
              </div>
              <table
                class="benifit-detail"
                v-if="currentBenifitItemShowIndex === index"
                :key="'table'+index"
              >
                <tr>
                  <td>{{$t('index.benifitAddress')}}</td>
                  <td>
                    <span>{{subStrAddress(item.address)}}</span>
                  </td>
                </tr>
                <tr>
                  <td>{{$t('index.benifitMoney')}}</td>
                  <td>{{item.payMoney/Math.pow(10, 8)}}WICC</td>
                </tr>
                <tr>
                  <td class="copy-container">{{$t('index.tradeHash')}}</td>
                  <td>
                    <span>{{item.hash}}</span>
                    <img src="@/assets/img/copy.svg" alt @click="copy(item.hash)">
                  </td>
                </tr>
                <tr>
                  <td>{{$t('index.benifitCode')}}</td>
                  <td>{{getDecimalSystem(item.benifitCode)}}</td>
                </tr>
              </table>
            </template>
          </template>
          <template v-else>
            <div class="no-record">
              <img src="@/assets/img/icon_norecord@2x.png" alt>
              <div class="text">{{$t('index.noRecord')}}</div>
              <div class="go-spend" @click="showRecordModel = false">{{$t('index.goSpend')}}</div>
            </div>
          </template>
        </div>
        <!-- 投注 -->
        <div class="spend-list" v-else>
          <template v-if="spendList.length">
            <template v-for="(item, index) in spendList">
              <!-- 未开奖 -->
              <div class="spend-item" :key="'item' + index" v-if="!Number(item.publishMark)">
                <div class="num">
                  <span class="spend-num">{{$t('index.spendCode')+getDecimalSystem(item.spendCode)}}</span>
                  <span class="yet">{{$t('index.noPublishBenifit')}}</span>
                </div>
                <div class="info">
                  <span class="address">{{subStrAddress(item.address)}}</span>
                  <span class="sum">{{$t('index.spendMoney')+item.spendMoney/Math.pow(10, 8)}}WICC</span>
                </div>
              </div>
              <!-- 已开奖 -->
              <div class="spend-item" :key="'item' + index" v-else>
                <div class="num">
                  <span class="spend-num">{{$t('index.spendCode')+getDecimalSystem(item.spendCode)}}</span>
                  <span>{{$t('index.publishBenifitCode')+getDecimalSystem(item.benifitCode)}}</span>
                  <span
                    class="finished"
                    v-if="Number(item.benifitMark)"
                  >+{{item.payMoney/Math.pow(10, 8)}}WICC</span>
                  <span class="not-benifit" v-else>{{$t('index.noBenifit')}}</span>
                </div>
                <div class="info">
                  <span class="address">{{subStrAddress(item.address)}}</span>
                  <span class="sum">{{$t('index.spendMoney')+item.spendMoney/Math.pow(10, 8)}}WICC</span>
                </div>
              </div>
            </template>
          </template>
          <template v-else>
            <div class="no-record">
              <img src="@/assets/img/icon_norecord@2x.png" alt>
              <div class="text">{{$t('index.noRecord')}}</div>
              <div class="go-spend" @click="showRecordModel = false">{{$t('index.goSpend')}}</div>
            </div>
          </template>
        </div>
      </div>
    </model>
  </div>
</template>

<script>
import model from "@/components/Model.vue";
import { setInterval, setTimeout } from "timers";
import Vue from "vue";
import VueClipboard from "vue-clipboard2";
import utils from "@/assets/js/utils";
import VueSlider from "vue-slider-component";
import "vue-slider-component/theme/default.css";

Vue.use(VueClipboard);
export default {
  components: {
    model,
    VueSlider
  },
  data() {
    return {
      showHelpModel: false,
      showRecordModel: false,
      showBenifitDetail: false,
      benifitModelTab: 0,
      selectNum: -1,
      benifitList: [],
      setIntervalRecord: null,
      address: "",
      benifitCodeList: [],
      balance: 0,
      prizePoolBalance: 0,
      spendList: [],
      spendCodeList: [],
      currentBenifitItemShowIndex: -1,
      setIntervalMoney: null,
      spendSum: 1,
      // regId:"2429714-1",
      regId: "1698831-2",
      // 滑块配置
      sliderOption: {
        min: 0.1,
        max: 10,
        interval: 0.1,
        processStyle: { backgroundColor: "#ffffff" },
        railStyle: { backgroundColor: "#82c0ff", height: "0.02rem" },
        dotSize: [16, 16],
        tooltip: "none",
        dotStyle: {
          boxShadow: '0px 2px 3px #007AD6'
        }
      }
    };
  },
  watch: {
  },
  created() {
    // 判断今日投注次数是否初始化,未初始化则初始化
    let date = localStorage.getItem("date");
    let today = utils.dataFormate(new Date());
    if (!date || date !== today) {
      localStorage.setItem("date", today);
      localStorage.setItem("spendSum", "0");
    }
    // 获取上次设置的投注金额
    let spendLast = localStorage.getItem("spendLast");
    if (spendLast) {
      this.spendSum = Number(spendLast);
    }
  },
  mounted() {
    // this.recordFresh();
    const _this = this;
    this.$vux.loading.show({
      text: "Loading"
    });
    _this.getContractInfo();
    // 定时刷新中奖历史
    this.setIntervalRecord = setInterval(() => {
      _this.getContractInfo();
    }, 10000);
    // 定时刷新奖池和账户的余额
    this.setIntervalMoney = setInterval(() => {
      _this.getMoney();
    }, 20000);
    // 获取用户钱包地址
    setTimeout(function() {
      _this.getAddressInfo();
    }, 1000);
  },
  methods: {
    subStrAddress(address) {
      return `${address.substr(0, 8)}...${address.substr(-4)}`;
    },
    showBeniiftDetail(index) {
      this.currentBenifitItemShowIndex =
        this.currentBenifitItemShowIndex === index ? -1 : index;
    },
    // 复制
    copy(text) {
      const _this = this;
      this.$copyText(text).then(
        function(e) {
          _this.$vux.toast.text(_this.$t("index.copyCue"));
        },
        function(e) {
          console.log(e);
        }
      );
    },
    // 根据地址或合约regid获取金额
    getInfoFromAddress(address) {
      const _this = this;
      // return this.$http.get(`/api/chain/account/${address}?date=${new Date().getTime()}`);
      return this.$http.post(`/api/account/getaccountinfo`, {
        address: address,
      });
    },
    // 用户当前用户钱包地址
    getAddressInfo() {
      const _this = this;
      waykiBridge.walletPlugin(
        "getAddressInfo",
        {},
        function(res) {
          if (Number(res.errorCode) === 0) {
            _this.address = res.result.address;
            console.log(_this.address)
            // _this.getSpendList();
            _this.getMoney().then(() => {
              _this.$vux.loading.hide();
            });
            // _this.getInfoFromAddress(res.result.address).then(res => {});
            // _this.getInfoFromAddress("142123-1").then(res => {});
          }
        },
        function(err) {
          _this.$vux.toast.text(err.errorMsg);
          _this.$vux.loading.hide();
        }
      );
    },
    // 获取奖池和账户的余额
    getMoney() {
      const _this = this;
      if (_this.address) {
        return _this.$http
          .all([
            _this.getInfoFromAddress(_this.address),
            _this.getInfoFromAddress(_this.regId)
          ])
          .then(
            _this.$http.spread(function(userRes, prizePoolRes) {
              // 获取用户余额
              console.log(userRes)
              _this.balance = userRes.data.data.balance / Math.pow(10, 8);
              // 获取奖池余额
              _this.prizePoolBalance = (
                prizePoolRes.data.data.balance / Math.pow(10, 8)
              ).toFixed(2);
            })
          );
      } else {
        console.log("请传入钱包地址");
      }
    },
    openRecordModel() {
      this.showRecordModel = true;
      this.getSpendList();
    },
    // 获取我的投注
    getSpendList() {
      const _this = this;
      this.spendList = [];
      this.spendCodeList = [];
      return this.$http
        .post("/api/contract/getcontractdata", {
          regid: this.regId,
          key: this.address + "myselfbet5",
          returndatatype: "HEX"
        })
        .then(res => {
          let resp = res.data;
          if (resp.data && resp.data.value) {
            let data = resp.data.value;
            for (let i = 0; i < 5; i++) {
              let singleData = data.slice(i * 198, i * 198 + 198);
              // 首字符为0则是空数据
              if (singleData.indexOf("0") !== 0) {
                this.spendCodeList.push(singleData);
                this.spendList.push(_this.getInfoFromCode(singleData));
              }
            }
          }
        });
    },
    // 获取中奖历史
    getContractInfo() {
      const _this = this;
      return this.$http
        .post("/api/contract/getcontractdata", {
          regid: _this.regId,
          key: "recentwon5",
          returndatatype: "HEX"
        })
        .then(res => {
          let resp = res.data;
          if (resp.data && resp.data.value) {
            let data = resp.data.value;
            let recordScroll = document.getElementById("recordScroll");
            for (let i = 0; i < 5; i++) {
              let singleData = data.slice(i * 198, i * 198 + 198);
              // 记录不为空且是新记录添加到列表,第一个数字为0则是空数据
              if (
                singleData.indexOf("0") !== 0 &&
                _this.benifitCodeList.indexOf(singleData) === -1
              ) {
                _this.benifitCodeList.push(singleData);
                // let code = this.getInfoFromCode(singleData);
                this.benifitList.push(_this.getInfoFromCode(singleData));
                // 新记录向上滑动动画(记录大于5条)
                if (_this.benifitList.length > 5) {
                  recordScroll.style.transform = `translateY(${-0.21 *
                    (_this.benifitList.length - 5)}rem)`;
                }
              }
            }
          }
        });
    },
    // 将16进制字符串转为中奖信息
    getInfoFromCode(code) {
      return {
        address: this.codeToChar(code.slice(0, 68)), // 地址
        hash: code.slice(68, 132), //交易哈希
        spendCode: this.codeToChar(code.slice(132, 138)), // 投注号码
        publishMark: this.codeToChar(code.slice(138, 140)), // 开奖标志
        benifitMark: this.codeToChar(code.slice(140, 142)), // 中奖标志
        payMark: this.codeToChar(code.slice(142, 144)), // 赔付标志
        spendTimes: this.codeToNumber(code.slice(144, 152)), // 参加次数
        spendMoney: this.codeToNumber(code.slice(152, 168)), // 投注金额
        payMoney: this.codeToNumber(code.slice(168, 184)), // 赔付金额
        odds: this.codeToNumber(code.slice(184, 192)), // 赔率
        benifitCode: this.codeToChar(code.slice(192, 198)) // 开奖号码
      };
    },
    // 获取十进制数
    getDecimalSystem(num) {
      return parseInt(num, 2) || 0;
    },
    reverseString(str) {
      let temp = str.slice();
      return temp
        .split("")
        .reverse()
        .join("");
    },
    codeToNumber(code) {
      let reverseStr = this.reverseString(code),
        i = 0,
        numberStr = "",
        arr = [];
      while (i < reverseStr.length) {
        if (reverseStr[i] != 0) {
          numberStr = reverseStr.substring(i);
          if (numberStr.length % 2 != 0) {
            numberStr = "0" + numberStr;
          }
          numberStr = this.reverseString(numberStr);
          break;
        }
        i++;
      }
      for (let i = 0; i < numberStr.length; i += 2) {
        arr.push(numberStr.substr(i, 2));
      }

      return parseInt(arr.reverse().join(""), 16) || 0;
    },
    // 投注验证
    validate() {
      // 未选择投注号码提示
      if (this.selectNum === -1) {
        this.$vux.toast.text(this.$t("index.pleaseSelectNum"));
        return false;
      }
      let spendSum = +localStorage.getItem("spendSum");
      if (spendSum > 300) {
        this.$vux.toast.show({
          text: `<div>${this.$t("index.maxSpendCue")}</div>
          <div class='toast-self'>${this.$t("index.spendNextDay")}</div>`,
          width: "2.8rem",
          type: "text",
          time: 3000
        });
        return false;
      }
      return true;
    },
    // 投注
    spendConfirm() {
      if (!this.validate()) return;
      let contractField = this.numToCodeForContract(this.selectNum);
      const _this = this;
      waykiBridge.walletPlugin(
        "walletPluginContractInvoke",
        {
          regId: _this.regId, //合约id
          contractField: contractField, //合约字段
          inputAmount: String(_this.floatMul(_this.spendSum)), //输入金额（没有传0）
          remark: _this.$t("index.remark") //备注，如：猜数字
        },
        function(res) {
          // _this.$vux.toast.text("投注成功");
          let spendSum = +localStorage.getItem("spendSum");
          localStorage.setItem("spendSum", `${spendSum + _this.spendSum}`);
          localStorage.setItem("spendLast", `${_this.spendSum}`);
          _this.$vux.toast.show({
            text: `<div>${_this.$t(
              "index.spendSuccess"
            )}</div><div class='toast-self'>${_this.$t(
              "index.pleaseWait"
            )}</div>`,
            width: "2.8rem",
            type: "text",
            time: 3000
          });
        },
        function(err) {
          _this.$vux.toast.text(err.errorMsg);
        }
      );
    },
    codeToChar(code) {
      let arr = [];
      for (let i = 0; i < code.length; i += 2) {
        let temp = parseInt(code.slice(i, i + 2), 16);
        arr.push(String.fromCharCode(temp));
      }
      return arr.join("");
    },
    // 浮点数乘积
    floatMul(v) {
      let isInt = v%1 === 0
      if (isInt) return v * Math.pow(10, 8)
      return v * 10 * Math.pow(10, 8) / 10
    },
    // 调用合约数字转化
    numToCodeForContract(num) {
      let n =
        new Array(3 - num.toString(2).length).fill(0).join("") +
        num.toString(2);
      return (
        "f0010000" +
        (n.length === 2 ? `0${n}` : n)
          .split("")
          .map(item => Number(item.charCodeAt()).toString(16))
          .join("")
      );
    },
    numToCode(num) {
      return num
        .toString(2)
        .split("")
        .map(item => Number(item.charCodeAt()).toString(16))
        .join("");
    },
    recordFresh() {
      let count = 0;
      let recordScroll = document.getElementById("recordScroll");
      this.setIntervalRecord = setInterval(() => {
        count = count + 1;
        recordScroll.style.transform = `translateY(${-0.21 * count}rem)`;
        this.benifitList.push({
          address: "wMHkGQKHf4CXdZRRoez8b9YgYnPzGxbs3j",
          money: "0.2",
          num: count
        });
      }, 2000);
    }
  },
  beforeDestroy() {
    // 销毁定时器
    clearInterval(this.setIntervalRecord);
    clearInterval(this.setIntervalMoney);
  }
};
</script>
<style lang="scss">
.toast-self {
  margin-top: 0.1rem;
}
</style>

<style lang="scss" scoped>
// @import "../../assets/css/variable";
.home {
  width: 100%;
  min-height: 100%;
  box-sizing: border-box;
  background: url("../../assets/img/index_bg.png") no-repeat;
  background-size: 100% 100%;
  // background-attachment: fixed;
  padding: 0.08rem 0.17rem;
  padding-bottom: 0.2rem;
  // overflow: hidden;
  .header {
    display: flex;
    justify-content: space-between;
    align-items: center;
    color: #4399ef;
    font-size: 0.1rem;
    .help {
      img {
        width: 0.48rem;
        height: 0.39rem;
      }
    }
    .money {
      font-weight: bold;
      font-size: 0.1rem;
      background: url("../../assets/img/money_bg.svg");
      background-size: 100% 100%;
      width: 1.07rem;
      height: 0.32rem;
      display: flex;
      align-items: center;
      span {
        flex-grow: 1;
        text-align: right;
        padding-right: 0.14rem;
      }
      img {
        display: inline-block;
        width: 0.22rem;
        height: 0.22rem;
      }
    }
  }
  .count {
    margin-top: 0.13rem;
    font-size: 0.5rem;
    text-align: center;
    color: #ffffff;
    height: 0.5rem;
    line-height: 0.5rem;
    text-shadow: 0px 0.03rem 0px rgba(255, 255, 255, 0.15);
    font-weight: bold;
    font-family: DIN Alternate;
    span:nth-child(2) {
      font-size: 0.1rem;
    }
  }
  .odds {
    margin-top: 0.1rem;
    height: 0.17rem;
    line-height: 0.17rem;
    color: #ffffff;
    font-size: 0.12rem;
    font-weight: bold;
    text-align: center;
  }
  .spend-sum {
    width: 3rem;
    margin: auto;
    margin-top: 0.1rem;
    .label {
      display: flex;
      justify-content: space-between;
    }
    span {
      color: #ffffff;
      font-size: 0.14rem;
    }
    .slider {
      flex-grow: 1;
    }
  }
  .btn-group {
    display: flex;
    justify-content: space-between;
    margin-top: 0.06rem;
    .benift {
      background: url("../../assets/img/button_w@2x.png") no-repeat;
      color: #2c99ed;
      div:nth-child(1) {
        font-size: 0.16rem;
        font-weight: 800;
        height: 0.16rem;
        line-height: 0.16rem;
      }
      div:nth-child(2) {
        font-size: 0.1rem;
        height: 0.14rem;
        line-height: 0.14rem;
        opacity: 0.64;
      }
    }
    .sub {
      background: url("../../assets/img/button_y@2x.png") no-repeat;
      color: #ffffff;
      font-size: 0.16rem;
      font-weight: 800;
    }
    .btn {
      width: 1.75rem;
      height: 0.62rem;
      background-size: 100% 100%;
      text-align: center;
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
    }
  }
  .content {
    height: 4.06rem;
    background: url("../../assets/img/content_bg@2x.png") no-repeat;
    background-size: 100% 100%;
    padding: 0.16rem 0.22rem 0.27rem;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    box-sizing: border-box;
    .title {
      font-size: 0.16rem;
      color: #4399ef;
      height: 0.22rem;
      line-height: 0.22rem;
      font-weight: bold;
      text-align: center;
    }
    .record-list {
      margin-top: 0.11rem;
      height: 1.05rem;
      overflow: hidden;
      #recordScroll {
        transition: 0.5s;
      }
    }
    .record-item {
      display: flex;
      font-size: 0.1rem;
      color: #495b7e;
      justify-content: space-between;
      height: 0.21rem;
      line-height: 0.21rem;
      padding: 0 0.11rem;
      .benifit{
        flex-grow: 1;
        padding-left: 0.18rem;
        text-align: left;
      }
      .address {
        width: 1rem;
        display: inline-block;
        text-overflow: ellipsis;
        overflow: hidden;
        white-space: nowrap;
      }
    }
    .num-list {
      display: flex;
      justify-content: space-between;
      color: #ffffff;
      padding-top: 0.1rem;
      .num-btn {
        width: 0.68rem;
        height: 0.68rem;
        background: url("../../assets/img/num_bg@2x.png") no-repeat;
        background-size: 100% 100%;
        font-size: 0.2rem;
        text-align: center;
        line-height: 0.68rem;
      }
      .num-btn-active {
        background: url("../../assets/img/selected_num_bg@2x.png") no-repeat;
        background-size: 100% 100%;
      }
    }
    .record-item:nth-child(2n-1) {
      background: rgba(68, 179, 244, 0.2);
    }
    .record-item:nth-child(2n) {
      background: rgba(211, 242, 255, 0.3);
    }
  }
  .help-model {
    padding: 0 0.2rem;
    font-size: 0.13rem;
    color: #495b7e;
    .sub-title {
      font-size: 0.15rem;
      font-weight: 800;
    }
    .sub-content {
      line-height: 0.2rem;
      margin-top: 0.05rem;
    }
    .title {
      font-size: 0.15rem;
      color: #1c89dc;
      font-weight: bold;
      text-align: center;
      margin-top: 0.16rem;
      height: 0.21rem;
      line-height: 0.21rem;
    }
    .problem {
      margin-top: 0.21rem;
    }
  }
  .record-model {
    position: relative;
    height: 100%;
    .no-record {
      text-align: center;
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      .text {
        margin-top: 0.08rem;
        color: #c8ced9;
        font-size: 0.16rem;
        height: 0.22rem;
        font-weight: 400;
        line-height: 0.22rem;
      }
      .go-spend {
        font-size: 0.16rem;
        color: #ffffff;
        height: 0.44rem;
        width: 1.64rem;
        background: url("../../assets/img/button@2x.png") no-repeat;
        background-size: 100% 100%;
        font-weight: 800;
        text-align: center;
        line-height: 0.44rem;
        margin: 0.3rem auto 0;
      }
      img {
        width: 0.8rem;
        height: 0.8rem;
      }
    }
    .tab-list {
      display: flex;
      z-index: 1;
      justify-content: space-between;
      background-color: #c2e4ff;
      .tab-item:nth-child(2) {
        margin-left: 0.03rem;
      }
      .tab-item {
        border-radius: 0.12rem 0.12rem 0px 0px;
        flex-grow: 1;
        height: 0.5rem;
        text-align: center;
        line-height: 0.5rem;
        background: #e0f1ff;
        font-size: 0.16rem;
        color: rgba(73, 91, 126, 0.5);
        font-weight: bold;
      }
      .tab-item-acive {
        background-color: #ffffff;
        color: #1c89dc;
      }
    }
    .benifit-list {
      height: calc(100% - 0.5rem);
      box-sizing: border-box;
      overflow: scroll;
      padding: 0.2rem 0;
      position: relatie;
      .title-column {
        display: flex;
        justify-content: space-between;
        align-items: center;
        color: #495b7e;
        font-size: 0.15rem;
        font-weight: bold;
        padding: 0 0.2rem;
        .address-column {
          width: 50%;
        }
        div {
          width: 25%;
          text-align: center;
        }
      }
      .benifit-detail {
        background-color: #eef7ff;
        width: 100%;
        border: 0;
        margin-top: 0.07rem;
        td {
          height: 0.3rem;
          font-size: 0.11rem;
          color: #495b7e;
          line-height: 0.3rem;
        }
        td:nth-child(2n-1) {
          text-align: center;
          display: inline-block;
          width: calc(100% - 2.38rem);
        }
        td:nth-child(2n) {
          width: 2.38rem;
          display: inline-block;
          padding-left: 0.2rem;
          box-sizing: border-box;
          position: relative;
          &::before {
            content: "";
            position: absolute;
            left: 0;
            top: 0;
            bottom: 0;
            width: 1px;
            background-color: rgba(73, 91, 126, 0.14);
            transform: scaleX(0.5);
          }
          span {
            display: inline-block;
            width: 1.68rem;
            text-overflow: ellipsis;
            overflow: hidden;
            white-space: nowrap;
          }
          img {
            width: 0.12rem;
            height: 0.12rem;
            position: absolute;
            top: calc(50% - 0.06rem);
            right: 0.19rem;
          }
        }
        tr {
          td {
            position: relative;
            &::after {
              content: "";
              position: absolute;
              bottom: 0;
              left: 0;
              right: 0;
              height: 1px;
              background-color: rgba(73, 91, 126, 0.14);
              transform: scaleY(0.5);
            }
          }
        }
        tr:last-child {
          border: 0;
        }
      }
      .benifit-item {
        display: flex;
        align-items: center;
        justify-content: space-between;
        margin-top: 0.26rem;
        padding: 0 0.2rem;
        .down {
          transition: 0.5s;
        }
        .up {
          transform: rotate(180deg);
        }
        .address {
          width: 50%;
          text-overflow: ellipsis;
          display: inline-block;
          overflow: hidden;
          white-space: nowrap;
          height: 0.18rem;
          line-height: 0.18rem;
        }
        div {
          width: 25%;
          text-align: center;
          color: #495b7e;
          font-size: 0.13rem;
        }
        .money {
          color: #f0a408;
        }
        .code {
          text-align: right;
          img {
            margin-left: 0.13rem;
          }
        }
      }
    }
    .spend-list {
      position: absolute;
      overflow: scroll;
      top: 0.5rem;
      bottom: 0;
      left: 0;
      right: 0;
      padding: 0.2rem;
      .spend-item:nth-child(1) {
        margin-top: 0;
      }
      .spend-item {
        margin-top: 0.26rem;
        .num {
          display: flex;
          // justify-content: space-between;
          font-size: 0.13rem;
          align-items: center;
          height: 0.21rem;
          line-height: 0.21rem;
          color: #495b7e;
          span:nth-child(2) {
            margin-left: 0.3rem;
          }
          span:last-child {
            flex-grow: 1;
            text-align: right;
          }
          .spend-num {
            font-weight: bold;
          }
          .not-benifit {
            color: rgba(73, 91, 126, 0.5);
            font-size: 0.13rem;
          }
          .finished {
            color: #f0a408;
            font-size: 0.13rem;
          }
          .yet {
            font-size: 0.13rem;
            color: #1c89dc;
            font-weight: 400;
          }
        }
        .info {
          display: flex;
          justify-content: space-between;
          font-size: 0.13rem;
          color: #495b7e;
          height: 0.18rem;
          line-height: 0.18rem;
          .address {
            width: 1.57rem;
            text-overflow: ellipsis;
            display: inline-block;
            overflow: hidden;
            white-space: nowrap;
          }
        }
      }
    }
  }
}
</style>